# *******************************************************************************
#
#  module:       cn.com
#
#  ------------------------------------------------------------------------------
#
#  responsible:  Bernd Vorsprach (D025588 - mailto:Bernd.Vorsprach@SAP-AG.de)
#
#  special area: Database Manager
#
#  description:  COM Description for all c(++) sources of the cn layer
#
#  see also:
#
#  ------------------------------------------------------------------------------
#
#                         Copyright by SAP AG, 1998
#
# *******************************************************************************

*       -DCN72 noshrglob
&if $OS in [ WIN32 ]
*       -FR                                        # MSDEV source browser
# *       -DBVMEMDEBUG -D_DEBUG -D_CRTDBG_MAP_ALLOC  # MSDEV memory debug
&endif

&quick
*       d -DDBM_TRACE_FLAG
&endquick

dbmapi.idl binary

gcn00.h     inc=gsp00,geo572.h,gcn00_1.h
gcn00_1.h   inc=geo200.h,geo47.h,hin100.h
gcn002.h
gcn003.h

vcn10.cpp inc=hcn20.h,hcn30.h,hcn31.h,hcn32.h,hcn40.h,hcn41.h,hcn42.h,hcn50.h,hcn51.h,hcn80.h,hcn81.h,hcn82.h,hcn83.h,hcn84.h,hcn90.h,vsp001,vsp009c,heo02.h,heo06.h,hsp100.h,hin101.h

vcn11.cpp inc=hcn14.h

vcn12.cpp inc=gsp09.h,heo02.h,hcn14.h,hcn90.h,hsp100.h,heo06.h

hcn13.h   inc=gsp00
vcn13.cpp inc=hcn13.h,vsp001,heo02.h,heo03.h,vsp009c

hcn14.h    inc=gsp00,geo47.h
vcn14.c    inc=hcn14.h,gsp09.h,vsp004,heo03.h
vcn14-p.c  inc=hcn14.h,gsp09.h,vsp004,heo03.h -DNOWINAPI

&if $OS in [ WIN32 ]
vcn16-a.c   inc=hsp100.h,hcn14.h -I$ACTIVEPERL_INCLUDE -DWIN32 -DMSWIN32 -DPERL_OBJECT -TP
vcn16-c.c   inc=hsp100.h,hcn14.h -I$COREPERL_INCLUDE -DWIN32 -DMSWIN32 -DWIN32IO_IS_STDIO
vcn16-a.cpp inc=hcn14.h -I$ACTIVEPERL_INCLUDE -DWIN32 -DMSWIN32 -DPERL_OBJECT
vcn16-c.cpp inc=hcn14.h -I$COREPERL_INCLUDE -DWIN32 -DMSWIN32 -DWIN32IO_IS_STDIO
&else
vcn16-c.c   inc=hsp100.h,hcn14.h -I$COREPERL_INCLUDE
vcn16-c.cpp inc=hcn14.h -I$COREPERL_INCLUDE
&endif

vcn17.c   inc=hsp100.h,hcn14.h -I$PYTHON_INCLUDE -I$PYTHON
vcn17.cpp inc=hcn14.h -I$PYTHON_INCLUDE

hcn20.h   inc=gcn00.h
vcn20.cpp inc=hcn90.h,hcn20.h,hcn23.h,hcn29.h,hcn52.h,heo02.h,hcn50.h,hcn51.h,hcn80.h,heo06.h,heo11.h,hsp100.h,geo002xp.h

hcn21.h   inc=gcn002.h,gcn00.h
vcn21.cpp inc=hcn90.h,hcn21.h,hcn29.h,heo06.h,heo02.h

hcn22.h   inc=gcn002.h,gcn00.h
vcn22.cpp inc=hcn90.h,hcn22.h,heo06.h

hcn23.h   inc=gcn002.h,gcn00.h
vcn23.cpp inc=hcn90.h,hcn23.h,hcn29.h

hcn29.h   inc=gcn002.h,gcn00.h
vcn29.cpp inc=hcn90.h,hcn80.h,hcn29.h,heo02.h,hsp02.h,heo06.h,heo11.h,hcn21.h,hcn23.h,hcn52.h,geo002xp.h,hsp100.h

hcn30.h   inc=gcn003.h,gcn00.h
vcn30.cpp inc=hcn90.h,hcn42.h,hcn20.h,hcn30.h,heo02.h,heo06.h,hcn50.h,hcn51.h,hcn80.h

hcn31.h   inc=gcn003.h,gcn00.h
vcn31.cpp inc=hcn90.h,hcn31.h,hin29.h,hcn20.h,hcn30.h,hcn80.h,heo02.h,heo06.h,heo11.h,gkb03,hcn35.h,hin101.h,geo002xp.h,hcn51.h,hsp77.h

hcn32.h   inc=gcn003.h,gcn00.h
vcn32.cpp inc=hcn90.h,hcn31.h,hcn32.h,hcn35.h,hcn42.h,heo02.h,heo06.h


hcn35.h		inc=gcn00.h,gcn003.h,hcn90.h,hin29.h,hcn36.h
vcn35.cpp	inc=hcn20.h,hcn32.h,hcn35.h,hcn351.h,hcn352.h,hcn353.h,hcn42.h

hcn351.h	inc=hcn35.h
vcn351.cpp	inc=hcn351.h,hcn36.h,hni34.h

hcn352.h    inc=hni31.h,hcn35.h
vcn352.cpp  inc=hcn352.h,hni34.h,hcn36.h

hcn353.h	inc=hni31.h,hcn35.h
vcn353.cpp	inc=hcn353.h,hni34.h,hcn42.h

hcn36.h		inc=hni00b.h,hni33.h,hni34.h,hni35.h,hcn361.h,hcn90.h
vcn36.cpp	inc=hni31.h,hcn36.h,hcn51.h

hcn361.h	inc=geo00.h
vcn361.cpp	inc=hni00b.h,hcn361.h

vcn37.cpp	inc=hni32.h,hni34.h,hni35.h,hcn361.h

hcn38.h		inc=hni00b.h,hni32.h,hni33.h,hni34.h
vcn38.cpp	inc=hcn38.h,hcn382.h,hcn383.h,hcn384.h,hcn361.h,hcn385.h

hcn381.h	inc=hcn38.h
vcn381.cpp	inc=hcn361.h,hcn381.h,hcn385.h

hcn382.h	inc=hcn38.h,hcn381.h
vcn382.cpp	inc=hcn361.h,hcn382.h,hcn385.h

hcn383.h	inc=hcn38.h,hcn381.h
vcn383.cpp	inc=hcn361.h,hcn383.h,hcn385.h

hcn384.h	inc=hcn38.h,hcn381.h
vcn384.cpp	inc=hcn361.h,hcn384.h,hcn385.h

hcn385.h	inc=hni34.h,hni35.h
vcn385.cpp	inc=hcn361.h,hcn385.h

hcn40.h   inc=gcn00.h
vcn40.cpp inc=hcn90.h,hcn42.h,hcn20.h,hcn30.h,hcn31.h,hcn40.h,hcn50.h,hcn80.h,hcn82.h,hcn51.h,vsp001,gsp09.h,heo02.h,heo03.h,heo06.h,hsp100.h,geo28.h,geo43.h,heo11.h,hin101.h,hin110.h

&if $MACH in [ NMP ]
&ifdef BIT64
# no optimization at SNI64 because with optimization the stack will
# not restored correctly after the call of ven904c::sqlxregisterinstNew()
# in vcn40.cpp::cn40InstReg()
vcn40.cpp -NO
&endif
&endif

hcn41.h   inc=gcn00.h
vcn41.cpp inc=hcn90.h,hcn41.h,hcn50.h,hcn51.h,hcn20.h,vsp009c,vsp001,geo28.h

hcn42.h   inc=gcn00.h
vcn42.cpp inc=hcn90.h,hcn20.h,hcn42.h,heo06.h

hcn50.h   inc=gcn00.h
vcn50.cpp inc=hcn29.h,hcn50.h,hcn51.h,hcn80.h,hcn90.h,hsp02.h,geo47.h,heo11.h,geo28.h,heo02.h

hcn51.h   inc=gsp00
vcn51.cpp inc=hcn51.h,hcn90.h,hcn42.h,heo06.h

hcn52.h   inc=gsp00
vcn52.cpp inc=hcn52.h,hcn42.h,hcn90.h,heo06.h,heo02.h

hcn80.h   inc=gcn00.h,hin29.h,hcn50.h
vcn80.cpp inc=hcn90.h,hcn20.h,hcn31.h,hcn51.h,hcn80.h,heo02.h,hsp02.h,vsp001,vsp009c

hcn81.h   inc=gcn00.h
vcn81.cpp inc=hcn90.h,hcn80.h,hcn81.h

hcn82.h   inc=gcn00.h
vcn82.cpp inc=hcn90.h,hcn51.h,hcn80.h,hcn82.h,geo47.h

hcn83.h   inc=gcn00.h
vcn83.cpp inc=hcn51.h,hcn90.h,hcn80.h,hcn83.h,hin110.h

hcn84.h   inc=gcn00.h
vcn84.cpp inc=hcn40.h,hcn90.h,hcn84.h

hcn90.h   inc=gcn00.h
vcn90.cpp inc=hcn90.h,heo06.h,heo02.h,hsp02.h,heo01.h,vsp001,vsp009c

#Test
vcn800.cpp -x=compcpc++

# RFC Server
hcn900rfcsrv.h       inc=:sap/saprfc.h,:sap/sapitab.h
vcn900rfcsrv.cpp     inc=hcn900rfcsrv.h

hcn901dbmrfc.h       inc=geo47.h,hin100.h,hcn900rfcsrv.h
vcn901dbmrfc.cpp     inc=hcn901dbmrfc.h,hcn903dbmsrv.h,hcn904table.h,hcn90.h

vcn902rfcmain.cpp    inc=hcn901dbmrfc.h -except

hcn903dbmsrv.h       inc=gsp00,geo47.h
vcn903dbmsrv.cpp     inc=hcn903dbmsrv.h,hcn14.h,heo02.h,hcn90.h
vcn903dbmsrv-d.cpp   inc=hcn903dbmsrv.h,hcn14.h

hcn904table.h        inc=:sap/saprfc.h,:sap/sapitab.h,hcn900rfcsrv.h
vcn904table.cpp      inc=hcn904table.h
