/*


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end


*/
#if defined(CN72) && defined(_WIN32)
  #line 3 "d:\\v72\\sys\\src\\cn\\hcn42.h"
#endif 

/*! 
  -----------------------------------------------------------------------------
 
  module: hcn41.h
 
  -----------------------------------------------------------------------------
 
  responsible:  BerndV
 
  special area: DBMServer File Access
   
  description:  DBMServer File Access - Specification

  version:      7.2.* / 7.1.* / 6.2.9.* 

  -----------------------------------------------------------------------------
 
                          Copyright by SAP AG, 1998
 
  -----------------------------------------------------------------------------
*/

#ifndef _HCN42_H_
#define _HCN42_H_

/*
  -----------------------------------------------------------------------------
  includes
  -----------------------------------------------------------------------------
 */
#include "gcn00.h"

/*
  -----------------------------------------------------------------------------
  specification public macros
  -----------------------------------------------------------------------------
 */

#define FGET_KNLDIAG_CN42          (*(tsp00_Namec *) _T("KNLDIAG"    ))
#define FGET_KNLDIAGERR_CN42       (*(tsp00_Namec *) _T("KNLDIAGERR" ))
#define FGET_KNLDIAGOLD_CN42       (*(tsp00_Namec *) _T("KNLDIAGOLD" ))
#define FGET_KNLTRC_CN42           (*(tsp00_Namec *) _T("KNLTRC"     ))
#define FGET_KNLDUMP_CN42          (*(tsp00_Namec *) _T("KNLDUMP"    ))
#define FGET_KNLEVT_CN42           (*(tsp00_Namec *) _T("KNLEVT"     ))
#define FGET_RTEDUMP_CN42          (*(tsp00_Namec *) _T("RTEDUMP"    ))
#define FGET_UTLPRT_CN42           (*(tsp00_Namec *) _T("UTLPRT"     ))
#define FGET_BACKHIST_CN42         (*(tsp00_Namec *) _T("BACKHIST"   ))
#define FGET_BACKMDF_CN42          (*(tsp00_Namec *) _T("BACKMDF"    ))
#define FGET_BACKEBF_CN42          (*(tsp00_Namec *) _T("BACKEBF"    ))
#define FGET_BACKEBP_CN42          (*(tsp00_Namec *) _T("BACKEBP"    ))
#define FGET_LOADPRT_CN42          (*(tsp00_Namec *) _T("LOADPRT"    ))
#define FGET_XSRVPRT_CN42          (*(tsp00_Namec *) _T("XSRVPRT"    ))
#define FGET_XSRVPRTOLD_CN42       (*(tsp00_Namec *) _T("XSRVPRTOLD" ))
#define FGET_REPMAN_CN42           (*(tsp00_Namec *) _T("REPMAN"     ))
#define FGET_DBMPRT_CN42           (*(tsp00_Namec *) _T("DBMPRT"     ))
#define FGET_DBMMDF_CN42           (*(tsp00_Namec *) _T("DBMMDF"     ))
#define FGET_DBMPAHI_CN42          (*(tsp00_Namec *) _T("DBMPAHI"    ))
#define FGET_CTRLMDF_CN42          (*(tsp00_Namec *) _T("CTRLMDF"    ))
#define FGET_CTRLLOG_CN42          (*(tsp00_Namec *) _T("CTRLLOG"    ))
#define FGET_DBMCFG_CN42           (*(tsp00_Namec *) _T("DBMCFG"     ))
#define FGET_PARAM_CN42            (*(tsp00_Namec *) _T("PARAM"      ))
#define FGET_LCINIT_CN42           (*(tsp00_Namec *) _T("LCINIT"     ))
#define FGET_LCINITCMD_CN42        (*(tsp00_Namec *) _T("LCINITCMD"  ))
#define FGET_LCINITHIS_CN42        (*(tsp00_Namec *) _T("LCINITHIS"  ))
#define FGET_APOCOMTRC_CN42        (*(tsp00_Namec *) _T("APOCOMTRC"  ))
#define FGET_LCTRC_CN42            (*(tsp00_Namec *) _T("LCTRC"      ))
#define FGET_LCBIN_CN42            (*(tsp00_Namec *) _T("LCBIN"      ))
#define FGET_INSTPRT_CN42          (*(tsp00_Namec *) _T("INSTPRT"    ))
#define FGET_USER_CN42             (*(tsp00_Namec *) _T("DBMUPC"     ))
#define FGET_KNLTRCPRT_CN42        (*(tsp00_Namec *) _T("KNLTRCPRT"  ))

/*!
  -----------------------------------------------------------------------------
  function:     cn42DirCreate
  -----------------------------------------------------------------------------

  description:  creates a directory

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42DirCreate
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42DirOpen
  -----------------------------------------------------------------------------

  description:  opens a directory an reads the first packet of entries

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42DirOpen
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42DirReadNext
  -----------------------------------------------------------------------------

  description:  reads the next packet of directory entries

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42DirReadNext
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42DirClose
  -----------------------------------------------------------------------------

  description:  closes a directory

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42DirClose
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileOpen
  -----------------------------------------------------------------------------

  description:  opens a file in the requested mode

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileOpen
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileSeek
  -----------------------------------------------------------------------------

  description:  moves the read/write psoition in a file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileSeek
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileErase
  -----------------------------------------------------------------------------

  description:  deletes a file by name

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileErase
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileClose
  -----------------------------------------------------------------------------

  description:  closes a file bay handle

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileClose
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileInfo
  -----------------------------------------------------------------------------

  description:  get info for one or more files by name

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileInfo
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileRead
  -----------------------------------------------------------------------------

  description:  opens a file and reads the first block of contents

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileRead
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileReadNext
  -----------------------------------------------------------------------------

  description:  continue reading file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileReadNext
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileWrite
  -----------------------------------------------------------------------------

  description:  opens a file and writes the first block of contents

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileWrite
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileWriteNext
  -----------------------------------------------------------------------------

  description:  continue writing file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileWriteNext
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileGet
  -----------------------------------------------------------------------------

  description:  opens a special db file and reads the first block of contents

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileGet
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileGetNext
  -----------------------------------------------------------------------------

  description:  continue reading special db file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileGetNext
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileGetList
  -----------------------------------------------------------------------------

  description:  list "getable" files

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileGetList
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);
/*!
  -----------------------------------------------------------------------------
  function:     cn42FileBackup
  -----------------------------------------------------------------------------

  description:  backups the specified special db file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileBackup
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42FileRestore
  -----------------------------------------------------------------------------

  description:  restores the specified special db file

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                command     [IN]     - DBMServer command
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply
                replyLenMax [IN]     - max. length of reply buffer

  return value: error code specified in gcn00c.h
 
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42FileRestore
      ( VControlDataT * vcontrol,
        CommandT      * command,
        char          * replyData,
        int           * replyLen,
        int             replyLenMax);

/*!
  -----------------------------------------------------------------------------
  function:     cn42BackupFile
  -----------------------------------------------------------------------------

  description:  backup one file 

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                szType      [IN]     - file to backup (FGET_*_CN42 value)
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply

  return value: error code specified in gcn00c.h
 
  prototypes:   2
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42BackupFile
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        _TCHAR            * replyData,
        tsp00_Int4        & replyLen );
tcn00_Error cn42BackupFile
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType);

/*!
  -----------------------------------------------------------------------------
  function:     cn42RestoreFile
  -----------------------------------------------------------------------------

  description:  restore one file 

  arguments:    vcontrol    [INOUT]  - DBMServer session data
                szType      [IN]     - file to restore (FGET_*_CN42 value)
                replyData   [OUT]    - reply buffer
                replyLen    [OUT]    - lenght of reply

  return value: error code specified in gcn00c.h
 
  prototypes:   2
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42RestoreFile
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        _TCHAR            * replyData,
        tsp00_Int4        & replyLen );
tcn00_Error cn42RestoreFile
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType);

/*!
  -----------------------------------------------------------------------------
  function:     cn42GetFileName
  -----------------------------------------------------------------------------

  description:  compute filenames for a special db file

  arguments:    szDbName     [IN]     - Name of database
                szType       [IN]     - file to backup (FGET_*_CN42 value)
                szFileName   [OUT]    - full filename
                szFileDir    [OUT]    - file directory
                szBackupName [OUT]    - full backupname
                szBackupDir  [OUT]    - backup directory
                bBinary      [OUT]    - is this a binary 
  return value: error code specified in gcn00c.h
 
  prototypes:   9
  -----------------------------------------------------------------------------
 */
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName,
        tsp00_C264c       & szBackupName,
        bool              & bBinary);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        bool              & bBinary);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName,
        bool              & bBinary);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_C264c   szType,  
        tsp00_C264c       & szFileName,
        bool              & bBinary);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName,
        tsp00_C264c       & szBackupName);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName,
        bool              & bBinary,
        tsp00_C256c       & szFileDir);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_Namec   szType,  
        tsp00_C264c       & szFileName,
        tsp00_C264c       & szBackupName,
        bool              & bBinary,
        tsp00_C256c       & szFileDir,
        tsp00_C256c       & szBackupDir);
tcn00_Error cn42GetFileName
      ( tsp00_DbNamec       szDbName,
        const tsp00_C264c   szType,  
        tsp00_C264c       & szFileName,
        tsp00_C264c       & szBackupName,
        bool              & bBinary,
        tsp00_C256c       & szFileDir,
        tsp00_C256c       & szBackupDir);

/*!
  -----------------------------------------------------------------------------
  function:     cn42RemoveFiles
  -----------------------------------------------------------------------------

  description:  removes all databasefiles with the remove flag

  arguments:    szDbName     [IN]     - Name of database
  -----------------------------------------------------------------------------
 */
void cn42RemoveFiles
      ( tsp00_DbNamec       szDbName);

/*!
  -----------------------------------------------------------------------------
  function:     cn42OpenFile
  -----------------------------------------------------------------------------

  description:  Opens a specified file.

                This function opens a file in this order:

                - try to open the original file
                - if fail, restore the backup file
                - try again to open the original file
                - if fail, open the backup file
                - uf fail return with an error


  arguments:    szDbName     [IN]     - Name of database
                szType       [IN]     - file find (FGET_*_CN42 value)
                fileMode     [IN]     - open mode (read, write, append)
                hFile        [OUT]    - the handle for the virtual file function
                                        of the RTE
                errFile      [OUT]    - structure for native virtual file error

  return value: vf_ok or vf_notok
  -----------------------------------------------------------------------------
 */
#ifdef GSP05_H
tcn00_Error cn42OpenFile
      ( tsp00_DbNamec        szDbName,
        const tsp00_Namec  & szType, 
        tsp5_rte_filemode    fileMode,
        tsp00_Int4         & hFile,
        tsp5_rte_fileerror & errFile);
#endif

#endif /* _HCN42_H_ */
