/****************************************************************************

  module      : gen41.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: IPC Resources
  description : Handling routines for IPC Resources
  
  last changed: 1999-12-07  17:02
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEN41_H
#define GEN41_H

/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#include "geo00.h"
#include "gen00.h"

/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/

externC int	sql41_create_sem ( key_t key ,
							  int   ref ,
							  int   range ,
							  int   mode ,
							  uid_t uid ,
							  char *type ,
							  char *dbname );

externC int sql41_remove_sem ( int  *semid ,
							  char *type ,
							  char *dbname );

externC int	sql41_create_shm ( key_t key ,
							  int   ref ,
							  int   range ,
							  int   size ,
							  int   mode ,
							  uid_t uid ,
							  char *type ,
							  char *dbname );

externC int sql41_remove_shm ( int  *shmid ,
							   char *type ,
							   char *dbname );

externC	char *sql41AttachShm ( int   shmid , 
                               char *address,
                               int   shmflag );

externC char *sql41_attach_shm ( int   shmid , 
                                 char *address );

externC int   sql41_detach_shm ( char **address );

externC void  sql41_stat_sem ( int semid );

externC void  sql41_stat_shm ( int shmid );

externC int   sql41_create_fifo ( tsp00_VFilenamec file ,
								  int perm );
externC int   sql41_remove_fifo ( tsp00_VFilenamec file );

externC void  sql41_get_ukp_net_fifo_name ( tsp00_VFilenamec file ,
										    char *dbname ,
											int ukp_index ,
											int net_index );

externC void  sql41_get_request_fifo_name ( tsp00_VFilenamec file ,
										    char *dbname );
externC void  sql41_get_reply_fifo_name ( tsp00_VFilenamec file ,
										  char *dbname ,
										  pid_t pid ,
										  tsp_int4 ref );

externC int   sql41_create_idfile ( char *usertype ,
								    char *dbname ,
									char restype ,
									int ipcid );

externC int   sql41_remove_idfile ( char *usertype ,
								    char *dbname ,
									char restype ,
									int ipcid );

externC FILE *sql41_fopen_idfile ( char *usertype ,
								   char *dbname ,
								   char  restype ,
								   int   ipcid );

externC key_t sql41_get_server_key ( tsp00_DbNamec dbname );

#ifdef OLD
externC key_t sql41_get_csl_key ( tsp00_DbNamec dbname );
#endif /* OLD */

externC void  sql41_get_idfile_name ( tsp00_VFilenamec file ,
									  char *usertype ,
									  char *dbname ,
									  char  restype ,
									  int   ipcid );
externC void  sql41_get_paramfile_name ( tsp00_VFilenamec file ,
										 char *dbname );

externC int	  sql41_check_spool_dirs ( void );

externC int   sql41_check_dir ( tsp00_VFilenamec file );

externC void  sql41_get_param_dir ( tsp00_VFilenamec file );

externC void  sql41_get_ipc_dir ( tsp00_VFilenamec file );

externC void  sql41_get_diag_dir ( tsp00_VFilenamec file );

externC void  sql41_get_fifo_dir ( tsp00_VFilenamec file );

externC void  sql41_get_spool_dir ( tsp00_VFilenamec file );

/* PTS 1104922 */
externC int   en41FindDatabaseProcess(const char *Source, const char *DbName, const char *kernelpgm);
externC int   en41BuildDatabaseProcessScan(const char *dbn, char *Buffer, int BufferSize);
externC int   en41BuildXShowCommand(const char *pgmpath, char *Buffer, int BufferSize);
#endif  /* GEN41_H */
