/****************************************************************************

  module      : geo001.h

  -------------------------------------------------------------------------

  responsible : Raymond Roedling (D024857 - Raymond.Roedling@SAP-AG.de)

  special area: RTE - system specific types, defines ...
  description : 


  last changed: 1999-03-29  16:24
  see also    : 

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998

*****************************************************************************/


#ifndef GEO001_H
#define GEO001_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#if defined(_WIN32)
#define _WIN32_WINNT 0x0400
# include <windows.h>
#else /* UNIX */
# include <errno.h>
# include <unistd.h>
#endif


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#if defined(_WIN32)
# define NO_ERROR_EO001                   NO_ERROR
# define ERROR_FILE_NOT_FOUND_EO001       ERROR_FILE_NOT_FOUND
# define ERROR_PATH_NOT_FOUND_EO001       ERROR_PATH_NOT_FOUND
# define ERROR_ALREADY_EXISTS_EO001       ERROR_ALREADY_EXISTS
# define ERROR_ACCESS_DENIED_EO001        ERROR_ACCESS_DENIED
# define ERROR_NOT_ENOUGH_MEMORY_EO001    ERROR_NOT_ENOUGH_MEMORY
# define ERROR_OUTOFMEMORY_EO001          ERROR_OUTOFMEMORY
#else /* UNIX */
# define NO_ERROR_EO001                   0
# define ERROR_FILE_NOT_FOUND_EO001       ENOENT
# define ERROR_PATH_NOT_FOUND_EO001       ENOENT
# define ERROR_ALREADY_EXISTS_EO001       EEXIST
# define ERROR_ACCESS_DENIED_EO001        EACCES
# define ERROR_NOT_ENOUGH_MEMORY_EO001    ENOMEM
# define ERROR_OUTOFMEMORY_EO001          ENOMEM
#endif



/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/

  /* further types and defines for both platforms can be found in heo15.h */
#if defined(_WIN32) || defined(WIN32)
 typedef  unsigned long   teo001_SystemRc;
 typedef  DWORD           teo001_Pid;
 typedef  DWORD           teo001_NumOfBytes;
#else
 typedef  int             teo001_SystemRc;
 typedef  size_t          teo001_NumOfBytes;
#ifdef LINUX
 /* special case... pid_t must not be used in typedef */
 typedef int             teo001_Pid;
#else
 typedef pid_t           teo001_Pid;
#endif
#endif


# define UNDEF_ERROR        ((teo001_SystemRc)-1)    
/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/


/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



#endif  /* GEO001_H */
