/****************************************************************************

  module      : geo50_0.h

  -------------------------------------------------------------------------

  responsible : JoergM

  special area: OS dependend include file for LZU kernel specific structures
  description : Exists only to prevent vmake from complaining too often


  last changed: 2000-11-27  12:04
  see also    : example.html ...

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*****************************************************************************/


#ifndef GEO50_0_H
#define GEO50_0_H



/*===========================================================================*
 *  INCLUDES                                                                 *
 *===========================================================================*/

#if defined(_WIN32)
#ifdef KERNEL_LZU
#ifndef KERNEL
#define KERNEL
#endif /* KERNEL */
#endif /* KERNEL_LZU */
#include "vos00kc.h" /* nocheck */
#else
#ifdef KERNEL_LZU
#ifndef USE_KGS
#define USE_KGS
#endif /* KGS */
#endif /* KERNEL_LZU */
#include "gen50.h" /* nocheck */
#endif


/*===========================================================================*
 *  DEFINES                                                                  *
 *===========================================================================*/

#if defined(_WIN32) || defined(OS2)
#define KGS         (&kgs)
#define TASK_CTRL              PTASK_CTRL_REC
#define TASK_TYPE(_pTaskCtrl) (_pTaskCtrl)->TaskType
#define TASK_STATE(_pTaskCtrl) (_pTaskCtrl)->TaskState
#define CURR_TASK             (THIS_UKT_CTRL)->pCTask
#define CURR_TASK_STATE       (THIS_UKT_CTRL)->pCTask->TaskState
#else
#define KGS         kgs
#define TASK_CTRL             struct TASK_TYPE *
#define TASK_TYPE(_pTaskCtrl) (_pTaskCtrl)->type
#define TASK_STATE(_pTaskCtrl) (_pTaskCtrl)->state
#define CURR_TASK             (THIS_UKT_CTRL)->curr_task
#define CURR_TASK_STATE       (THIS_UKT_CTRL)->curr_task->state
#endif

/* PTS 1106176 */
#define NUMBER_OF_BLOCKIO_RETRIES 3

/*===========================================================================*
 *  MACROS                                                                   *
 *===========================================================================*/


/*===========================================================================*
 *  CLASSES, STRUCTURES, TYPES, UNIONS ...                                   *
 *===========================================================================*/


/*===========================================================================*
 *  FUNCTION PROTOTYPES                                                      *
 *===========================================================================*/


/*===========================================================================*
 *  EXTERNAL VARIABLES                                                       *
 *===========================================================================*/



#endif  /* GEO50_0_H */
