/* @lastChanged: "1998-05-08  8:29"
 *
 * @filename:   hin29.h
 * @purpose:    "Exports for SQL package handling"
 * @release:    7.1.0.0
 * @see:        ""
 *
 * @copyright:  "Copyright by   SAP AG, 1997"


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 */

#ifndef HIN29_H
#define HIN29_H

#include "vsp001.h"
#include "vsp0031.h"
#include "gin01.h"

/* ------------------------------- */
/* specification public functions */
/* ------------------------------- */
int i29utilbackupcmd (
     tin01_sql_session       * pSession,
     tin01_c_sqlca           * pSqlca,
     boolean                 * bBackupRC,
     boolean                   bBackupState,
     tin01_cstr                cmd,
     ... );

int i29utilbackuprequest (
     tin01_sql_session       * pSession,
     boolean                   bBackupState,
     tin01_cstr                cmd );

int i29utilbackupreceive (
     tin01_sql_session       * pSession,
     tin01_c_sqlca           * pSqlca,
     boolean                 * bBackupRC,
     ... );

int i29utildiagtocmd (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     long                    * nPageSize,
     void                   ** pPageBuf );

int i29utildiagrestcmd (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     long                      nPageSize,
     const void              * pPageBuf );

void i29errmsg (
     tin01_sql_session       * pSession,
     tsp00_C256c             & errbuf);

void i29initsession (
    tin01_sql_session       * pSession,
    tsp1_packet             * pPacket);

void i29pascalstring (
     char                    * target,
     int                       targetlen,
     const char              * source,
     int                       sourcelen );

tin01_sql_session * i29lasterr_on (
     tin01_sql_session       * pSession );

int i29specialconnect (
      tin01_sql_session      * pSession );

int i29eventconnect (
      tin01_sql_session      * pSession );

int
i29eventwait (
      tin01_sql_session       * pSession,
      tsp31_event_description * event);

void i29sqllasterr (
      tin01_sql_session      * pSession,
      tsp00_ErrTextc         & errtext,
      tsp00_KnlIdentifierc   & errname,
      tsp00_Int2             * errcode,
      tsp00_Int2             * errpos );

void i29specialrelease (
      tin01_sql_session      * pSession );

#define i29eventrelease i29specialrelease

int i29utility (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd );

void i29release (
      tin01_sql_session      * pSession,
      tin01_bool               bWithCommit );

int i29sqlconnect (
      tin01_sql_session      * pSession );

int i29fetchnice (
     tin01_sql_session       * pSession,
     char                    * pResult,
     long                      nResultLen);

int i29selectnice (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     char                    * pResult,
     long                      nResultLen,
     bool                      bOneRowResult,
     bool                      bDesc,
	 bool                      bDataOnly);

int i29selectinfo (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     char                    * pResult,
     char                      cFieldSep );

int i29fetch (
     tin01_sql_session       * pSession,
     char                    * pResult,
     long                      nResultLen,
     char                      cFieldSep,
     char                      cStringDel,
     char                      cRecSep );

int i29select (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     char                    * pResult,
     long                      nResultLen,
     char                      cFieldSep,
     char                      cStringDel,
     char                      cRecSep );

int i29record (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd);

int i29nextrecord (
     tin01_sql_session       * pSession);

int i29fieldvalue (
     tin01_sql_session       * pSession,
     const tsp00_Int4          nField,
     tin01_c_hostvar         * pHostvar,
     const char                cStringQuote = 0);

int i29adbs (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd );

int i29adbs_noinfo (
    tin01_sql_session * session,
    tin01_cstr cmd);

int i29adbsf (
     tin01_sql_session       * pSession,
     tin01_cstr                cmd,
     ...);

int i29utilcmd (
     tin01_sql_session       * pSession,
     tin01_c_sqlca           * pSqlca,
     tin01_cstr                cmd,
     ... );

int i29replyavailable (
     tin01_sql_session       * pSession );

void i29cancel (
     tin01_sql_session       * pSession );

int i29sqlcmd (
     tin01_sql_session       * pSession,
     tin01_c_sqlca           * pSqlca,
     tin01_cstr                cmd,
     ... );

int i29fetchcmd (
     tin01_sql_session       * pSession,
     tin01_cstr              cmd,
     int                     vars);

int
i29switch (
    tin01_sql_session        * session,
    tin01_cstr               trace,
    tin01_cstr               test);

int
i29switchlimit (
    tin01_sql_session        * session,
    tin01_cstr               trace,
    tin01_cstr               test,
    tin01_cstr               start,
    tin01_cstr               stop,
    int                      limit);

int
i29buflimit (
    tin01_sql_session        * session,
    int                      limit);

int
i29minbuf (
    tin01_sql_session        * session);

int
i29maxbuf (
    tin01_sql_session        * session);

void
i29initparse (
    tin01_sql_session * session);

void
i29pcmd (
    tin01_sql_session * session,
    tin01_cstr cmd,
    int len);

void
i29pcmdf (
    tin01_sql_session * session,
    tin01_cstr cmd,
    ...);

int
i29sql (
    tin01_sql_session * session,
    tin01_sqlresult * sqlresult);

void
i29gparseid (
    tin01_sql_session * session,
    tin01_parseid pid);

int
i29paramcount (
    tin01_sql_session * session);

tsp1_param_info *
i29gparaminfo (
    tin01_sql_session * session,
    int i);

void
i29initexecute (
    tin01_sql_session * session,
    tin01_parseid pid);

void
i29initspecial (
    tin01_sql_session * session,
    tsp1_cmd_mess_type_Param messType);

int
i29droppid (
    tin01_sql_session * session,
    tin01_parseid pid);

tin01_byte           *
i29argaddr (
    tin01_sql_session * session,
    tsp00_Int4 bufpos);

tin01_bool
i29findpart (
    tin01_sql_session * session,
    tsp1_part_kind_Param requiredKind);

int
i29parg (
    tin01_sql_session * session,
    const tin01_byte * arg,
    int varlen,  /* in bytes */
    int sqllen,  /* in bytes */
    tsp00_Int4 bufpos,
    char defByte);

void
i29pnull (
    tin01_sql_session * session,
    int sqllen,
    tsp00_Int4 bufpos);

tsp1_part      *
i29newpart (
    tin01_sql_session * session,
    tsp1_part_kind_Enum partKind);

tin01_bool
i29gresulttablename (
    tin01_sql_session * session,
    int              * len,
    char             * resulttablename);

tsp00_Int4
i29partlen (
    tin01_sql_session * session);

char           *
i29getpart (
    tin01_sql_session * session);

char           *
i29argsbuf (
    tin01_sql_session * session);

tsp00_Int4
i29nameslen (
    tin01_sql_session * session);

tin01_cstr
i29colnames (
    tin01_sql_session * session);

void
i29extendpart (
    tin01_sql_session * session,
    int lendiff);

void
i29getFreePartInfo (
    tin01_sql_session * session,
    void ** dataptr,
    int   * bufPos,
    int   * freeLen);

int
i29requestForPython (
    tin01_sql_session * session,
    tin01_sqlresult * sqlresult);
int
i29receiveForPython (
    tin01_sql_session * session,
    tin01_sqlresult * sqlresult);

#endif
