/*!================================================================
 module:    gpr01.h

 responsible: BurkhardD
 
 special area:   CPCDrv | Client | Prototypes fuer vpr01
 
 description: 
 
 see:  
 


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

#ifndef __GPR01_H__
#define __GPR01_H__

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/

#include "gpr00.h"
#include "gpr01b.h"
#include "gpr01e.h"
#include "gpr01l.h"
#include "gpr01s.h"
#include "gpr01s.h"

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/

typedef enum tpr01_DescTypeEnum {
  UnknownDesc_epr01,
  EnvDesc__epr01, 
  ModuleDesc_epr01, 
  ConDesc_epr01, 
  PrecomDesc_epr01, 
  StmtNameDesc_epr01, 
  SQLDesc_epr01, 
  CursorDesc_epr01, 
  CommandDesc_epr01, 
  ErrorDesc_epr01,
  SegDesc_epr01
} tpr01_DescTypeEnum;

typedef enum tpr01_SQLStateBinary { 
  Empty_bpr01     = 0x00, 
  Allocated_bpr01 = 0x01, 
  Prepared_bpr01  = 0x02, 
  Executed_bpr01  = 0x04, 
  Opened_bpr01    = 0x08, 
  Closed_bpr01    = 0x10,
  StatusAll_bpr01 = (Empty_bpr01-1)
} tpr01_SQLStateBinary;

typedef enum tpr01_ConnectOptionBinary { 
  NoSelectDirectFast_bpr01 = 0x01
} tpr01_ConnectOptionBinary;

typedef enum tpr01_SQLStatementOptionEnum { 
  First_epr01, 
  Append_epr01, 
  Reference_epr01
} tpr01_SQLStatementOptionEnum;

typedef enum tpr01_StmtTypeEnum { 
  StmtEmpty_epr01, 
  StmtSelect_epr01, 
  StmtDeclare_epr01, 
  StmtFetch_epr01, 
  StmtGetval_epr01,
  StmtPutval_epr01,
  StmtClose_epr01, 
  StmtSingleSelect_epr01, 
  StmtOther_epr01 = -1
} tpr01_StmtTypeEnum;

typedef enum tpr01_StmtTypeExtraBinary {
  HasCursor_bpr01 = 0x01, 
  ExtrAll_bpr01 = (Empty_bpr01-1)
} tpr01_StmtTypeExtraBinary;

typedef enum tpr01_KeywordTypeEnum {
  KeywordSELECT_epr01,
  KeywordINSERT_epr01,
  KeywordUPDATE_epr01,
  KeywordAPPEND_epr01,
  KeywordDELETE_epr01,
  KeywordCREATE_epr01,
  KeywordDECLARE_epr01,
  KeywordOPEN_epr01,
  KeywordFETCH_epr01,
  KeywordGETVAL_epr01,
  KeywordPUTVAL_epr01,
  KeywordDROP_epr01,
  KeywordPROC_epr01,
  KeywordSHOW_epr01,
  KeywordNEXT_epr01,
  KeywordFIRST_epr01,
  KeywordLAST_epr01,
  KeywordPREV_epr01,
  KeywordDISTINCT_epr01,
  KeywordDIRECT_epr01,
  KeywordDESCRIBE_epr01,
  KeywordCLOSE_epr01,
  KeywordNOT_FOUND_epr01 = -1
} tpr01_KeywordTypeEnum;

#define EmptyUniqueID_cpr01 (0x00000000)
#define MinUniqueID_cpr01   (0x00010000)
typedef tsp00_Int4 tpr01_UniqueID;
typedef char tpr01_UniqueName[9];
/*==================================================================*
 *  FUNCTION PROTOTYPES                                             *
 *==================================================================*/

void p01varpart_get(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka);
void p01pparsidtrace (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, tpr00_ParseId VAR_ARRAY_REF parsid, tpr00_TraceParseID_Enum inout);
void p01cmd_trace (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka);
void p01prepstmtname(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01begi(sqlcatype *sqlca, sqlxatype *sqlxa, tsp00_Int2 sess); 
void p01execute(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka);
void p01searchgroupfunc (sqlcatype *sqlca, sqlxatype *sqlxa, BOOLEAN *massopen, BOOLEAN *parspre);
void p01nameallocinfo(sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore);
void p01resallocinfo(sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore);
void p01allocsfinfo(sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore);
boolean pr01cParsePrepare(struct tpr01_SQLDesc *SQLDesc);
boolean pr01cParse(struct tpr01_SQLDesc *SQLDesc, tsp00_Int2 *cmdfetch, boolean *datafound);
void pr01cOpen(struct tpr01_SQLDesc *SQLDesc);
void pr01cBeg(struct tpr01_SQLDesc *SQLDesc);
void pr01cEnd(struct tpr01_SQLDesc *SQLDesc);
void pr01cExecu(struct tpr01_SQLDesc *SQLDesc);
void pr01cOpenCursor(struct tpr01_SQLDesc *SQLDesc);
void pr01cDynmfetch (struct tpr01_SQLDesc *SQLDesc);
void pr01cDescribe (struct tpr01_SQLDesc *SQLDesc);
boolean pr01cIsComType(struct tpr01_SQLDesc *SQLDesc, tpr00_ComTypeEnum ComType);
void p01colinitsfinfo(sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore);
void p01colmovesfinfo (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore);
void p01nammovesfinfo(sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore, tpr00_ComTypeEnum getkatyp);
void p01resinitsfinfo (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore, BOOLEAN *prepars);
void p01resmovesfinfo (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore, BOOLEAN *prepars);
void p01adbsexecute (sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka, sqlorentry *ore, sqlcuentry *cu, tsp00_Int2 *cmdfetch, tsp1_cmd_mess_type *cmdtyp, BOOLEAN proc_begin);
void p01oradescribe  (sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga);
void p01makefetchinto (sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, int intopos);
void p01dynmfetch (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka);
void p01cmd_pars_execute(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka, sqlorentry *ore, sqlcuentry *cu);
void p01cmd_execute_immediate(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka);
void p01execu(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka);
void p01check(sqlcatype *sqlca, sqlxatype *sqlxa, tsp00_Int4 connplen);
void p01ma2bi(sqlcatype *sqlca, sqlxatype *sqlxa, tsp00_Int2 ma_no, tsp00_Int2 ma_len, tpr_macroline VAR_ARRAY_REF val);
struct tpr01_PrecomDesc *pr01cGetPrecomDesc(sqlxatype *sqlxa, tsp00_Int4 kano);
void p01beg(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01end(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01descr(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka);
void p01command(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, sqlkaentry *ka, tsp00_Int2 kano);
void p01stop(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01exit(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01cancel(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga, tsp00_Int2 kano);
void p01version(sqlcatype *sqlca, sqlxatype *sqlxa, tsp00_Int2 kano);
void p01_katyp_get(sqlcatype *sqlca, sqlxatype *sqlxa);
void p01opendata (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlcuentry *cu, BOOLEAN mass_cmd, BOOLEAN *found);
void p01usenewparsinfo (sqlcatype *sqlca, sqlxatype *sqlxa, sqlkaentry *ka, sqlorentry *ore, sqlcuentry *cu);
void p01resultnget(sqlcatype *sqlca, sqlxatype *sqlxa, sqlgaentry *ga);
sqlkaentry *pr01cDupKa(sqlkaentry *kae);
void pr01cFreeKa(sqlkaentry *kae);
void p01verstrace (sqlcatype *sqlca, sqlxatype *sqlxa, tsp00_Int2 art, tsp_c40 VAR_ARRAY_REF vers);
void p01putversion (sqlcatype *sqlca, sqlxatype *sqlxa, int vaind, tsp00_Int4 len, tsp_c40 VAR_ARRAY_REF vers,  tpr_runtime_errors_Enum *error, void *ptr);
#endif
