/*!================================================================
 module:    vpr01StmtName.h

 responsible: BurkhardD
 
 special area:   CPCDrv | Client | Statementnamen 
 description: Verwaltung von Statementnamen
 
 see:  
 


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

#ifndef __VPR01_STMTNAME_H__
#define __VPR01_STMTNAME_H__

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/

#include "gpr00.h"
#include "gpr01.h"
#include "vpr09DynaDesc.h"

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/

typedef struct tpr01_StmtNameDesc {
  tpr01_DescTypeEnum      DescType;
  struct tpr01_StmtNameContainer *StmtName;
  sqlsnentry  *sn;  
  tpr01_UniqueID UniqueID;    
  tpr00_StmtName szStmtName;    
  char *szSQLStatement;
  int cbLen;
  int cbAllocLen;
  tpr01_SQLStateBinary State;
  sqlkaentry *ka;
  sqlorentry *ore;
  sqlcuentry *cue;
  tpr01_StmtTypeEnum StmtType;
  tpr01_StmtTypeExtraBinary StmtTypeExtra;
} tpr01_StmtNameDesc;

typedef struct tpr01_StmtNameContainer {
  tpr09DynamicDescriptor *Desc;  
  void                (*InitCont)   (struct tpr01_StmtNameContainer *Cont);
  tsp00_Int4          (*OpenCont)   (struct tpr01_StmtNameContainer *Cont);
  void                (*CloseCont)  (struct tpr01_StmtNameContainer *Cont);
  tpr01_StmtNameDesc *(*AddDesc)    (struct tpr01_StmtNameContainer *Cont, char * szStmtName, tpr01_UniqueID UniqueID, sqlkaentry *ka);
  void                (*DeleteDesc) (struct tpr01_StmtNameDesc *Desc);
  tsp00_Int4          (*GetCount)   (struct tpr01_StmtNameContainer *Cont);
  tpr01_StmtNameDesc *(*EnumDesc)   (struct tpr01_StmtNameContainer *Cont);
  tsp00_Int4          (*SetIndex)   (struct tpr01_StmtNameContainer *Cont, tsp00_Int4);
  tpr01_StmtNameDesc *(*FindDesc)   (struct tpr01_StmtNameContainer *Cont, char *lsnname, tpr01_UniqueID UniqueID);
  char      *(*PutSQL)    (struct tpr01_StmtNameDesc *Desc, char *szSQLStatement, int *cbLen, tpr01_SQLStatementOptionEnum fOption);
  char      *(*GetSQL)    (struct tpr01_StmtNameDesc *Desc, char *szSQLStatement, int *cbLen, tpr01_SQLStatementOptionEnum fOption);
  void       (*TraceStmtName)    (struct tpr01_StmtNameDesc *Desc, sqlcatype *sqlca);
  void       (*SetState)  (struct tpr01_StmtNameDesc *Desc, tpr01_SQLStateBinary State);
  void       (*DropParsId)       (struct tpr01_StmtNameDesc *Desc, struct tpr01_SQLDesc *SQLDesc);

} tpr01_StmtNameContainer;

/*==================================================================*
 *  PROTOTYPES                                                      *
 *==================================================================*/

tpr01_StmtNameContainer *pr01StmtNameNewCont();

void pr01StmtNameDeleteCont(tpr01_StmtNameContainer *Cont);

void pr01StmtNameSnEntryInit(sqlsnentry *sn);

#endif
