/*!================================================================
 module:    vpr03Con.c

 responsible: BurkhardD
 
 special area:   Connection Verwaltung
 
 description: Connection Verwaltung
 
 see:  
 


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/
#include "vpr01Con.h"
#include "gpr03.h"
#include "gpr01e.h"
#include "vpr03Con.h"

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/

/*==================================================================*
 *  EXTERNAL PROTOTYPES                                             *
 *==================================================================*/

/*==================================================================*
 *  FUNCTION PROTOTYPES                                             *
 *==================================================================*/

/*==================================================================*
 *  CODE                                                            *
 *==================================================================*/

void pr03ConConnect (struct tpr01_ConDesc *ConDesc)
{
  M90TRACE(M90_TR_ENTRY, "pr03ConConnect", 0);
  {
    tpr01_ConContainer *Connection = ConDesc->Connection;
    sqlcatype *sqlca = Connection->sqlca;
    sqlxatype *sqlxa = ConDesc->sqlxa;
    sqlgatype *sqlga = sqlca->sqlgap;
    sqlratype *sqlra = sqlca->sqlrap;
    struct SQLERROR *sqlemp = sqlca->sqlemp;
    sqlgaentry *gaen = ConDesc->ga;
    sqlra->raactsession = ConDesc->SessionNr;
    p01xtracefilecheck  (sqlca, sqlxa);
    p03initsqlem (sqlemp);
    p03sendconnect (sqlra, sqlga, gaen, sqlemp);
    sqlga->gasqlconntyp = cpr_ci_connect;
    gaen->gareconnect = cpr_is_false;
    {
      tsp1_packet    *pck = (tsp1_packet*) gaen->garecptr;
      tsp1_segment_header *seghp
	= (pck) ? (tsp1_segment_header *)&pck->variant.C_2.sp1_segm_F.variant.C_1.sp1s_segm_header_F : NULL;
      
      if ((sqlemp->ereturncode == 0) &&
	  (seghp && seghp->sp1r_returncode == 0)) {
	gaen->gamesscode[0] = pck->sp1_header.sp1h_mess_code;
	pr03cSessionInfoGet(sqlra, gaen);
	if (gaen->gaKernelUnicode) {
	  const char *s = "Unicode database not supported";
	  sqlemp->eprerr = cpr_reflex_connect_notok;
	  sqlemp->elzu = sp1ce_notok;
	  memcpy(sqlemp->etext, s, strlen (s));	  
	  p03cseterror(sqlemp, sqlemp->eprerr);
	} 
	else {
	  if (sqlga->gacmpkind != CPR_LA_ODBC)
	    p03setformat (sqlra, gaen, sqlca->sqldatetime, sqlemp);
	  if (sqlemp->ereturncode != 0)
	    p03cseterror (sqlemp, cpr_set_format_error);
	}
      }
      /* p03NologSession(sqlga, cpr_is_false); */ /* PTS 1108090 */
    }
  }
  M90TRACE(M90_TR_EXIT, "pr03ConConnect", 0);
}

