/*!================================================================

  module:       vpr03Packet.c

 -------------------------------------------------------------------

  responsible:  BurkhardD

  special area: Auftragsinterface 

  description:  

  see also:

  -------------------------------------------------------------------------

  copyright:    Copyright by SAP AG, 1998



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/

#include "vpr03Packet.h"
#include "hsp26.h"

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/

#define PR03PACKET_KERNELVERSION_POS (2200)
#define PR03PACKET_KERNELVERSION_LEN (sizeof(PR03PACKET_UNKNOWN_VERSION)-1)

/*==================================================================*
 *  EXTERNAL PROTOTYPES                                             *
 *==================================================================*/

/*==================================================================*
 *  FUNCTION PROTOTYPES                                             *
 *==================================================================*/

/*==================================================================*
 *  CODE                                                            *
 *==================================================================*/

externC BOOLEAN 
pr03PacketGetKernelParameters( tsp1_segment *segm_ptr,
			       tpr03_KernelParam_Enum fOption,
			       void         *pKernelParam )
{
    tsp1_part_ptr part_ptr;
    if (segm_ptr) {
        s26find_part (segm_ptr, (char) sp1pk_session_info_returned, &part_ptr);
        if (part_ptr && pKernelParam) {
            switch(fOption) {
            case UnicodeCatalog_epr03 :{
                *((char *) pKernelParam) = (char) *part_ptr->sp1p_buf;
		return (TRUE);
                break;
            }
            case KernelVersionString_epr03:{
	      if ( part_ptr->variant.C_1.sp1p_part_header_F.sp1p_buf_len >= 
		   (PR03PACKET_KERNELVERSION_POS+PR03PACKET_KERNELVERSION_LEN)) {
		memcpy( pKernelParam, (part_ptr->variant.C_1.sp1p_buf_F+PR03PACKET_KERNELVERSION_POS), PR03PACKET_KERNELVERSION_LEN );
		((char*) pKernelParam)[PR03PACKET_KERNELVERSION_LEN] = '\0';
		return (TRUE);
	      }
	      break;
            }
            }; /* switch */
        }; /* if */
    }; /* if */
    return(FALSE);
} /* pr03PacketGetKernelParameters */

