/*!================================================================

  module:       vpr03Part.h

  responsible:  BurkhardD

  special area: Functions to modify a Part 


  description:  Header fuer Verwaltung des Auftragsinterfaces

  see also:     

 -------------------------------------------------------------------

                         Copyright by SAP AG, 2000



    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

 ===================================================================*/
#ifndef __VPR03_PART_H__
#define __VPR03_PART_H__

/*==================================================================*
 *  INCLUDES                                                        *
 *==================================================================*/

#include "gpr00.h"

/*==================================================================*
 *  DECLARATIONS                                                    *
 *==================================================================*/

/*==================================================================*
 *  PROTOTYPES                                                      *
 *==================================================================*/

externC tsp1_part *pr03PartFind(sqlratype *sqlra, tsp1_part_kind_Param part_kind);
externC tsp1_part *pr03PartFindDirect(sqlratype *sqlra, tsp1_part_kind_Param part_kind);
externC void pr03PartInitCache(sqlratype *sqlra);
externC void pr03PartPut(tsp1_part *partPtr, void *pBuf, tsp00_Int4 cbLen);
#endif
