/*                                                             
 abaphndl.h - definitions/declarations for standard processing
       of abap IO streams. This file extended the general 
       declaration from cpc.h of the SAP DB for R/3 C/C++ Precompiler

       Copyright (c) 1998, SAP AG


    ========== licence begin LGPL
    Copyright (C) 2000 SAP AG

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ========== licence end

*/
#ifndef __gpi00abaphndl_h__
#define __gpi00abaphndl_h__
&if $OS in [ WIN32 ]
#include <windows.h>
&endif
#include "lcstream.h"

enum SQLORATypes {
        SQL_ORA_VARCHAR2 = 1,
        SQL_ORA_NUMBER,
        SQL_ORA_FIXEDPOINTINTEGER,
        SQL_ORA_FLOATPOINT,
        SQL_ORA_NULLTERMINATEDSTRING,
        SQL_ORA_VARNUM,
        SQL_ORA_PACKEDDECIMAL,
        SQL_ORA_LONG,
        SQL_ORA_VARCHAR,
        SQL_ORA_ROWID,
        SQL_ORA_INTERNDATE   = 12,
	SQL_ORA_INTERNJULIAN = 14,
        SQL_ORA_VARRAW,
	SQL_ORA_RAW         = 23,
        SQL_ORA_LONGRAW,
        SQL_ORA_VFILE       = 39,   /* datafile Cobol */
        SQL_ORA_VFILEC      = 40,   /* datafile C */
	SQL_ORA_UNSIGNED    = 68,
	SQL_ORA_DISPLAY     = 91,
	SQL_ORA_LONGVARCHAR = 94,
        SQL_ORA_LONGVARRAW,
        SQL_ORA_CHAR,
        SQL_ORA_CHARZ,
	SQL_ORA_MLSLABEL    = 106,
	SQL_ORA_UNICODE     = 200,
	SQL_ORA_LONG_UNICODE= 201,
	SQL_ORA_ABAP_HANDLE = SQL_ORA_STREAM_HANDLE,
	SQL_ORA_LONG_DESC   = 401
    }; /* ORACLE types */

#define SQL_ABAP_OK           SQL_STREAM_OK
#define SQL_ABAP_ERROR        SQL_STREAM_ERROR
#define SQL_ABAP_EXCEPTION    SQL_STREAM_EXCEPTION
#define SQL_ABAP_NO_MORE_DATA SQL_STREAM_NO_MORE_DATA

#define SQLABAPReadProc       SQLStreamReadProc
#define SQLABAPWriteProc      SQLStreamWriteProc
#define SQLABAPDesc           SQLStreamDesc
#define SQL_LC_ABAPTabParm    SQL_LC_StreamParm
#define SQL_ORA_ABAP_HANDLE   SQL_ORA_STREAM_HANDLE

#endif
